# dbum

_Pronounced **dumb**_

A no-nonsense, JSON-based key-value store backed by [Daybreak](http://propublica.github.io/daybreak/)

## Usage

    $ dbum help
    Commands:
      dbum art             # View the application art
      dbum help [COMMAND]  # Describe available commands or one specific command
      dbum server          # Start the application Web server
      dbum version         # Echo the application version

You're probably most interested in the `server` command:

    $ dbum help server
    Usage:
      dbum server
    
    Options:
      -p, [--port=N]                   # Set Sinatra port
                                       # Default: 4567
      -e, [--environment=ENVIRONMENT]  # Set Sinatra environment
                                       # Default: development
      -b, [--bind=BIND]                # Set Sinatra interface
                                       # Default: 0.0.0.0
      -t, [--database=DATABASE]        # Location of application database
                                       # Default: um.db
      -d, [--debug], [--no-debug]      # Enable debugging output
    
    Start the application Web server

## API

### List keys `GET /`

Return the current list of keys.

### Lookup key `GET /:key`

Return the value associated with the given key. Returns `404` if the key does
not exist.

### Create key `POST /:key {}`

Associate the given key with the value contained in the request body, which must
be a valid JSON hash. Returns `404` if the key already exists.

### Replace key `PUT /:key {}`

Associate the given key with the value contained in the request body, which must
be a valid JSON hash. Returns `404` if the key does not exist.

### Update key `PATCH /:key {}`

Merge the value associated the given key with the contents of the request body,
which must be a valid JSON hash. Returns `404` if the key does not exist.

### Delete key `DELETE /:key`

Delete the key and its associated value.